<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <div>
    <el-form size="middle" :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'"
             label-width="100px" @submit.native.prevent>

      <el-divider content-position="left"><i class="el-icon-document"></i> 基础信息</el-divider>
      <el-row :gutter="26">
        <el-col :span="12">
          <el-form-item label="经办人" prop="userName">
            <el-input v-model="inputForm.userName" :disabled="true"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="报销编号" prop="no">
            <el-input v-model="inputForm.no" :disabled="true"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="所属部门" prop="departmentName">
            <el-input v-model="inputForm.departmentName" :disabled="true"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="报销日期" prop="reimDate" :rules="[{required: true, message:'请选择报销日期', trigger:'blur'}]">
            <el-date-picker
              placement="bottom-start"
              v-model="inputForm.reimDate"
              type="date"
              value-format="yyyy-MM-dd"
              style="width: 100%"
              placeholder="选择日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="报销类型" prop="sourceType"
                        :rules="[
                        {required: true, message:'请选择报销类型', trigger:'change'}
                 ]">
            <el-select v-model="inputForm.sourceType" @change="changeSourceType" placeholder="请选择报销类型" style="width:100%;">
              <el-option
                v-for="item in $dictUtils.getDictList('zs_reimbursement_source_type')"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="12" v-if="inputForm.sourceType === '5'">
          <el-form-item label="采购编号" prop="purchaseNo"
                        :rules="[{required: true, message:'采购编号不能为空', trigger:'blur'},
                              {required: true, message:'采购编号不能为空', trigger:'change'}]">
            <el-input size="medium" :readonly="true" @focus="openPurForm()" v-model="inputForm.purchaseNo" placeholder="请选择采购编号">
              <el-button slot="append" icon="el-icon-search" @click="openPurForm()"></el-button>
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item label="备注" prop="remarks">
            <el-input v-model="inputForm.remarks"
                      type="textarea"
                      :rows="5"
                      maxlength="500"
                      placeholder="请输入简介"
                      show-word-limit>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <div v-if="inputForm.sourceType === '5'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          采购详情
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod555"
            ref="preTable"
            class="vxe-table-element"
            :data="inputForm.preList"
            style="margin-left: 5em"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
          >
            <vxe-table-column field="purchaser" title="采购人" :edit-render="{}" :rules="[{required: true, message:'请选择采购人', trigger:'blur'}]"></vxe-table-column>
            <vxe-table-column field="procurementOffice" title="采购部门" :edit-render="{}"></vxe-table-column>
            <vxe-table-column field="procurementType" title="采购类型" :edit-render="{}" :rules="[{required: true, message:'请选择采购类型', trigger:'blur'}]"></vxe-table-column>
            <vxe-table-column field="tradeName" title="商品名称" :edit-render="{}" :rules="[{required: true, message:'请填写商品名称', trigger:'blur'}]"></vxe-table-column>
            <vxe-table-column field="tradePrice" title="商品单价(元)" :edit-render="{}" :rules="[{required: true, message:'请输入商品单价', trigger:'blur'}]"></vxe-table-column>
            <vxe-table-column field="tradeNumber" title="商品数量" :edit-render="{}"></vxe-table-column>
            <vxe-table-column field="priceSum" title="商品总价" :edit-render="{}"></vxe-table-column>
            <vxe-table-column field="company" title="单位" :edit-render="{}"></vxe-table-column>
            <vxe-table-column field="remarks" title="备注" :edit-render="{}"></vxe-table-column>
            <vxe-table-column title="操作">
              <template v-slot="scope">
                <el-button size="mini" type="primary" :disabled="false" @click="seeFileInfo(scope.$rowIndex)">文件详情</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <div v-if="inputForm.sourceType === '1'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          项目报销详情
          <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || status === 'audit' || status === 'taskFormDetail'" size="mini" @click="insertEvent('detail')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod"
            ref="detailTable"
            :key="detailKey"
            class="vxe-table-element"
            :data="inputForm.detailInfos"
            style="margin-left: 5em"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
            :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
            :edit-rules="validRules"
          >
            <vxe-table-column field="userName" title="报销人" :edit-render="{}" :rules="[{required: true, message:'请选择报销人', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.userName" @focus="userPullListForm(scope.$rowIndex)"></el-input>
  <!--              <UserSelectV2 :limit='1' :userName="scope.row.userName" @getValue='(value, label) => {scope.row.userName = label}'></UserSelectV2>-->
              </template>
            </vxe-table-column>
            <vxe-table-column field="deptName" title="报销部门" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :disabled='true' v-model="scope.row.deptName" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="typeName" title="报销类别" :edit-render="{}" :rules="[{required: true, message:'请选择报销类别', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.typeName" @focus="typePullForm(scope.$rowIndex, scope.row.deptId)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="projectName" title="报销项目" :edit-render="{}" :rules="[{required: true, message:'请选择报销项目', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.projectName" @focus="openProgramPageForm(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
<!--            <vxe-table-column field="reportNumber" title="报告号" :edit-render="{}">-->
<!--              <template v-slot:edit="scope">-->
<!--                <el-input :readonly="true" v-model="scope.row.reportNumber" @focus="openReportNoPageForm(scope.$rowIndex, scope.row)"></el-input>-->
<!--              </template>-->
<!--            </vxe-table-column>-->
            <vxe-table-column field="number" title="费用(元)" :edit-render="{}" :rules="[{required: true, message:'请输入费用', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input maxlength="15" v-model="scope.row.number" @keyup.native="scope.row.number = twoDecimalPlaces(scope.row.number)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="receiptNumber" title="收据张数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.receiptNumber" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="days" title="出差天数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.days" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="content" title="内容" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.content" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column title="操作" width="100">
              <template v-slot="scope">
                <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'detail')">删除</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <div v-if="inputForm.sourceType === '2'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          合同报销详情
          <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || status === 'audit' || status === 'taskFormDetail'" size="mini" @click="insertEvent('contract_detail')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod"
            ref="detailTableContract"
            :key="detailKeyContract"
            class="vxe-table-element"
            :data="inputForm.detailInfoContracts"
            style="margin-left: 5em"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
            :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
            :edit-rules="validRules"
          >
            <vxe-table-column field="userName" title="报销人" :edit-render="{}" :rules="[{required: true, message:'请选择报销人', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.userName" @focus="userPullListForm2(scope.$rowIndex)"></el-input>
                <!--              <UserSelectV2 :limit='1' :userName="scope.row.userName" @getValue='(value, label) => {scope.row.userName = label}'></UserSelectV2>-->
              </template>
            </vxe-table-column>
            <vxe-table-column field="deptName" title="报销部门" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :disabled='true' v-model="scope.row.deptName" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="typeName" title="报销类别" :edit-render="{}" :rules="[{required: true, message:'请选择报销类别', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.typeName" @focus="typePullForm2(scope.$rowIndex, scope.row.deptId)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="contractName" title="报销合同" :edit-render="{}" :rules="[{required: true, message:'请选择报销合同', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.contractName" @focus="openContractForm(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
<!--            <vxe-table-column field="reportNumber" title="报告号" :edit-render="{}">-->
<!--              <template v-slot:edit="scope">-->
<!--                <el-input :readonly="true" v-model="scope.row.reportNumber" @focus="openReportNoPageForm(scope.$rowIndex, scope.row)"></el-input>-->
<!--              </template>-->
<!--            </vxe-table-column>-->
            <vxe-table-column field="number" title="费用(元)" :edit-render="{}" :rules="[{required: true, message:'请输入费用', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input maxlength="15" v-model="scope.row.number" @keyup.native="scope.row.number = twoDecimalPlaces(scope.row.number)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="receiptNumber" title="收据张数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.receiptNumber" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="days" title="出差天数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.days" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="content" title="内容" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.content" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column title="操作" width="100">
              <template v-slot="scope">
                <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'contract_detail')">删除</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <div v-if="inputForm.sourceType === '3'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          报告报销详情
          <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || status === 'audit' || status === 'taskFormDetail'" size="mini" @click="insertEvent('report_detail')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod"
            ref="detailTableReport"
            :key="detailKeyReport"
            class="vxe-table-element"
            :data="inputForm.detailInfoReports"
            style="margin-left: 5em"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
            :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
            :edit-rules="validRules"
          >
            <vxe-table-column field="userName" title="报销人" :edit-render="{}" :rules="[{required: true, message:'请选择报销人', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.userName" @focus="userPullListForm3(scope.$rowIndex)"></el-input>
                <!--              <UserSelectV2 :limit='1' :userName="scope.row.userName" @getValue='(value, label) => {scope.row.userName = label}'></UserSelectV2>-->
              </template>
            </vxe-table-column>
            <vxe-table-column field="deptName" title="报销部门" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :disabled='true' v-model="scope.row.deptName" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="typeName" title="报销类别" :edit-render="{}" :rules="[{required: true, message:'请选择报销类别', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.typeName" @focus="typePullForm3(scope.$rowIndex, scope.row.deptId)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="projectName" title="报销项目" :edit-render="{}" :rules="[{required: true, message:'请选择报销项目', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.projectName" @focus="openProgramPageForm3(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="reportNumber" title="报告号" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :readonly="true" v-model="scope.row.reportNumber" @focus="openReportNoPageForm(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="number" title="费用(元)" :edit-render="{}" :rules="[{required: true, message:'请输入费用', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input maxlength="15" v-model="scope.row.number" @keyup.native="scope.row.number = twoDecimalPlaces(scope.row.number)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="receiptNumber" title="收据张数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.receiptNumber" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="days" title="出差天数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.days" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="content" title="内容" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.content" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column title="操作" width="100">
              <template v-slot="scope">
                <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'report_detail')">删除</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <div v-if="inputForm.sourceType === '4'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          其他报销详情
          <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || status === 'audit' || status === 'taskFormDetail'" size="mini" @click="insertEvent('others')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod"
            ref="detailTableOthers"
            class="vxe-table-element"
            :data="inputForm.detailInfoOthers"
            style="margin-left: 5em"
            :key="detailKeyOthers"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
            :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
            :edit-rules="validRules"
          >
            <vxe-table-column field="userName" title="报销人" :edit-render="{}" :rules="[{required: true, message:'请选择报销人', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.userName" @focus="userPullListForm4(scope.$rowIndex)"></el-input>
                <!--              <UserSelectV2 :limit='1' :userName="scope.row.userName" @getValue='(value, label) => {scope.row.userName = label}'></UserSelectV2>-->
              </template>
            </vxe-table-column>
            <vxe-table-column field="deptName" title="报销部门" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :disabled='true' v-model="scope.row.deptName" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="typeName" title="报销类别" :edit-render="{}" :rules="[{required: true, message:'请选择报销类别', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.typeName" @focus="typePullForm4(scope.$rowIndex, scope.row.deptId)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="projectName" title="报销详情" :edit-render="{}" :rules="[{required: true, message:'请填写报销详情', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.projectName" @focus="openProgramPageForm4(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
            <!--            <vxe-table-column field="reportNumber" title="报告号" :edit-render="{}">-->
            <!--              <template v-slot:edit="scope">-->
            <!--                <el-input :readonly="true" v-model="scope.row.reportNumber" @focus="openReportNoPageForm(scope.$rowIndex, scope.row)"></el-input>-->
            <!--              </template>-->
            <!--            </vxe-table-column>-->
            <vxe-table-column field="number" title="费用(元)" :edit-render="{}" :rules="[{required: true, message:'请输入费用', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input maxlength="15" v-model="scope.row.number" @keyup.native="scope.row.number = twoDecimalPlaces(scope.row.number)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="receiptNumber" title="收据张数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.receiptNumber" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="days" title="出差天数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.days" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="content" title="内容" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.content" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column title="操作" width="100">
              <template v-slot="scope">
                <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'others')">删除</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <div v-if="inputForm.sourceType === '5'">
        <el-divider content-position="left"><i class="el-icon-document"></i>
          采购报销详情
          <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || this.formReadOnly" size="mini" @click="insertEvent('procured')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15" >
          <vxe-table
            border
            show-footer
            show-overflow
            :footer-method="footerMethod"
            ref="detailTableProcured"
            class="vxe-table-element"
            :data="inputForm.detailInfoProcured"
            style="margin-left: 5em"
            :key="detailKeyProcured"
            @cell-click=""
            @edit-closed=""
            highlight-current-row
            :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
            :edit-rules="validRules"
          >
            <vxe-table-column field="userName" title="报销人" :edit-render="{}" :rules="[{required: true, message:'请选择报销人', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.userName" @focus="userPullListForm5(scope.$rowIndex)"></el-input>
                <!--              <UserSelectV2 :limit='1' :userName="scope.row.userName" @getValue='(value, label) => {scope.row.userName = label}'></UserSelectV2>-->
              </template>
            </vxe-table-column>
            <vxe-table-column field="deptName" title="报销部门" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input :disabled='true' v-model="scope.row.deptName" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="typeName" title="报销类别" :edit-render="{}" :rules="[{required: true, message:'请选择报销类别', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.typeName" @focus="typePullForm5(scope.$rowIndex, scope.row.deptId)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="projectName" title="报销项目" :edit-render="{}" :rules="[{required: true, message:'请选择报销项目', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.projectName" @focus="openProgramPageForm5(scope.$rowIndex, scope.row)"></el-input>
              </template>
            </vxe-table-column>
            <!--            <vxe-table-column field="reportNumber" title="报告号" :edit-render="{}">-->
            <!--              <template v-slot:edit="scope">-->
            <!--                <el-input :readonly="true" v-model="scope.row.reportNumber" @focus="openReportNoPageForm(scope.$rowIndex, scope.row)"></el-input>-->
            <!--              </template>-->
            <!--            </vxe-table-column>-->
            <vxe-table-column field="number" title="费用(元)" :edit-render="{}" :rules="[{required: true, message:'请输入费用', trigger:'blur'}]">
              <template v-slot:edit="scope">
                <el-input maxlength="15" v-model="scope.row.number" @keyup.native="scope.row.number = twoDecimalPlaces(scope.row.number)"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="receiptNumber" title="收据张数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.receiptNumber" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="days" title="出差天数" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.days" oninput ="value=value.replace(/\D|^0/g,'')" maxlength="10"></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column field="content" title="内容" :edit-render="{}">
              <template v-slot:edit="scope">
                <el-input v-model="scope.row.content" ></el-input>
              </template>
            </vxe-table-column>
            <vxe-table-column title="操作" width="100">
              <template v-slot="scope">
                <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'procured')">删除</el-button>
              </template>
            </vxe-table-column>
          </vxe-table>
        </el-row>
      </div>
      <el-divider content-position="left"><i class="el-icon-document"></i>
        专用发票信息
        <el-button style="margin-left: 20px" type="primary" :disabled="method==='view' || status === 'audit' || status === 'taskFormDetail' " size="mini" @click="insertEvent('amount')" plain>
          新增
        </el-button>
      </el-divider>
      <el-row  :gutter="15" >
        <vxe-table
          border
          show-overflow
          ref="amountTable"
          class="vxe-table-element"
          :data="inputForm.amountInfos"
          style="margin-left: 5em"
          @cell-click=""
          :key="amountKey"
          @edit-closed=""
          highlight-current-row
          :edit-config="{trigger: 'click', mode: 'row', showStatus: true, autoClear: true, icon:'_'}"
        >
          <vxe-table-column field="code" title="发票代码" :edit-render="{}">
            <template v-slot:edit="scope">
              <el-input oninput ="value=value.replace(/\D|^/g,'')" maxlength="20" v-model="scope.row.code" ></el-input>
            </template>
          </vxe-table-column>
          <vxe-table-column field="number" title="发票号" :edit-render="{}">
            <template v-slot:edit="scope">
              <el-input oninput ="value=value.replace(/\D|^/g,'')" maxlength="8" @change="isExict(scope.row)" v-model="scope.row.number" ></el-input>
            </template>
          </vxe-table-column>
          <vxe-table-column field="amount" title="金额" :edit-render="{}">
            <template v-slot:edit="scope">
              <el-input maxlength="15" v-model="scope.row.amount" @keyup.native="scope.row.amount = twoDecimalPlaces(scope.row.amount)" @change="countAmount(scope.row)"></el-input>
            </template>
          </vxe-table-column>
          <vxe-table-column field="taxAmount" title="税额" :edit-render="{}">
            <template v-slot:edit="scope">
              <el-input maxlength="15" v-model="scope.row.taxAmount" @keyup.native="scope.row.taxAmount = twoDecimalPlaces(scope.row.taxAmount)" @change="countAmount(scope.row)"></el-input>
            </template>
          </vxe-table-column>
          <vxe-table-column field="count" title="价税合计" :edit-render="{}">
            <template v-slot:edit="scope">
              <el-input disabled="true" v-model="scope.row.count" ></el-input>
            </template>
          </vxe-table-column>
          <vxe-table-column title="操作" width="100">
            <template v-slot="scope">
              <el-button size="mini" type="danger" @click="removeEvent(scope.row,scope.$rowIndex,'amount')">删除</el-button>
            </template>
          </vxe-table-column>
        </vxe-table>
      </el-row>

      <!-- 附件 -->
      <UpLoadComponent ref="uploadComponent"></UpLoadComponent>
<!--      <ProgramPageForm ref="programPageForm" @getProgram="getProgram"></ProgramPageForm>-->
      <CwProgramPageForm ref="cwProgramPageForm" @getProgram="getProgram"></CwProgramPageForm>
      <CwProgramPageForm ref="cwProgramPageForm3" @getProgram="getProgram3"></CwProgramPageForm>
      <CwProgramPageForm ref="cwProgramPageForm4" @getProgram="getProgram4"></CwProgramPageForm>
      <CwProgramPageForm ref="cwProgramPageForm5" @getProgram="getProgram5"></CwProgramPageForm>
<!--      <ReimbursementTypePullForm ref="reimbursementTypePullForm" @getProgramForType="getProgramForType"></ReimbursementTypePullForm>-->
      <CwReimbursementTypePullForm ref="cwReimbursementTypePullForm" @getProgramForType="getProgramForType"></CwReimbursementTypePullForm>
      <CwReimbursementTypePullForm ref="cwReimbursementTypePullForm2" @getProgramForType="getProgramForType2"></CwReimbursementTypePullForm>
      <CwReimbursementTypePullForm ref="cwReimbursementTypePullForm3" @getProgramForType="getProgramForType3"></CwReimbursementTypePullForm>
      <CwReimbursementTypePullForm ref="cwReimbursementTypePullForm4" @getProgramForType="getProgramForType4"></CwReimbursementTypePullForm>
      <CwReimbursementTypePullForm ref="cwReimbursementTypePullForm5" @getProgramForType="getProgramForType5"></CwReimbursementTypePullForm>

      <UserPullForm ref="userPullForm" @getProgramForUser="getProgramForUser"></UserPullForm>
      <UserPullForm ref="userPullForm2" @getProgramForUser="getProgramForUser2"></UserPullForm>
      <UserPullForm ref="userPullForm3" @getProgramForUser="getProgramForUser3"></UserPullForm>
      <UserPullForm ref="userPullForm4" @getProgramForUser="getProgramForUser4"></UserPullForm>
      <UserPullForm ref="userPullForm5" @getProgramForUser="getProgramForUser5"></UserPullForm>

    </el-form>
    <WorkContractChooseCom ref="workContractChooseCom" @getContract="getContract"></WorkContractChooseCom>
    <ReportNoChooseRadio ref="reportNoChooseRadio" @getWorkClientRadioChoose="getWorkClientChoose2"></ReportNoChooseRadio>
    <PurchaseChooseForm  ref="purchaseChooseForm" @getProject="getPurChoose"></PurchaseChooseForm>
    <MaterialManagementDialog ref="materialManagementDialog" @getUpload="getUpload"></MaterialManagementDialog>
  </div>
</template>

<script>
  import ReportNoChooseRadio from './ReportNoChooseRadio'
  import UserSelectV2 from '@/components/userSelectV2'
  import ReimbursementService from '@/api/zs/reimbursement/ReimbursementService'
  import ReimbursementTypeService from '@/api/zs/reimbursement/ReimbursementTypeService'
  import UpLoadComponent from '@/views/common/UpLoadComponent'
  import SelectUserTree from '@/views/modules/utils/treeUserSelect'
  import SelectTree from '@/components/treeSelect/treeSelect.vue'
  import XEUtils from 'xe-utils'
  import UserService from '@/api/sys/UserService'
  import CwProgramPageForm from './CwProgramPageForm'
  import CwReimbursementTypePullForm from './CwReimbursementTypePullForm'
  import UserPullForm from '@/views/modules/finance/invoice/UserPullForm'
  import CommonApi from '@/api/cw/common/CommonApi'
  import WorkContractChooseCom from '@/views/modules/cw/projectRecords/WorkContractChooseCom'
  import PurchaseChooseForm from '../../../materialManagement/wareHouse/PurchaseChooseForm'
  import MaterialManagementService from '@/api/materialManagement/MaterialManagementService'
  import MaterialManagementDialog from '../../../materialManagement/file/MaterialManagementDialog'
  export default {
    props: {
      businessId: {
        type: String,
        default: ''
      },
      formReadOnly: {
        type: Boolean,
        default: false
      },
      status: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        validRules: {
          userName: [
            {required: true, message: '报销人不能为空'}
          ],
          deptName: [
            {required: true, message: '报销部门不能为空'}
          ],
          typeName: [
            {required: true, message: '报销类型不能为空'}
          ],
          projectName: [
            {required: true, message: '报销项目不能为空'}
          ],
          contractName: [
            {required: true, message: '报销合同不能为空'}
          ],
          reportNumber: [
            {required: true, message: '报告号不能为空'}
          ],
          number: [
            {required: true, message: '费用(元)不能为空'}
          ]
        },
        title: '',
        method: '',
        visible: false,
        loading: false,
        indexRow: '',
        detailKey: '',
        detailKeyContract: '',
        detailKeyReport: '',
        detailKeyOthers: '',
        detailKeyProcured: '',
        inputForm: {
          userId: '',
          userName: '',
          no: '',
          department: '',
          reimDate: '',
          remarks: '',
          detailInfos: [],
          detailInfoContracts: [],
          detailInfoReports: [],
          detailInfoOthers: [],
          detailInfoProcured: [],
          amountInfos: [],
          files: [], // 附件信息
          procInsId: '',
          sourceType: '',
          preList: [],
          purchaseNo: '',
          tradeTotalPrice: '',
          purchaseId: '',
          departmentName: ''
        },
        keyWatch: '',
        amountKey: ''
      }
    },
    ReimbursementService: null,
    // reimbursementService: null,
    // reimbursementTypeService: null,
    reimbursementTypeService: null,
    userService: null,
    commonApi: null,
    materialManagementService: null,
    created () {
      this.reimbursementService = new ReimbursementService()
      // this.reimbursementService = new ReimbursementService()
      this.userService = new UserService()
      // this.reimbursementTypeService = new ReimbursementTypeService()
      this.reimbursementTypeService = new ReimbursementTypeService()
      this.commonApi = new CommonApi()
      this.materialManagementService = new MaterialManagementService()
    },
    components: {
      UpLoadComponent,
      SelectUserTree,
      SelectTree,
      // ProgramPageForm,
      CwProgramPageForm,
      // ReimbursementTypePullForm,
      CwReimbursementTypePullForm,
      UserPullForm,
      ReportNoChooseRadio,
      UserSelectV2,
      WorkContractChooseCom,
      PurchaseChooseForm,
      MaterialManagementDialog
    },
    computed: {
      bus: {
        get () {
          return this.businessId
        },
        set (val) {
          this.businessId = val
        }
      },
      name () {
        return JSON.parse(localStorage.getItem('user')).name
      },
      officeName () {
        return JSON.parse(localStorage.getItem('user')).officeDTO.name
      },
      userId () {
        return JSON.parse(localStorage.getItem('user')).id
      }
    },
    watch: {
      'keyWatch': {
        handler (newVal) {
          if (this.commonJS.isNotEmpty(this.bus)) {
            this.init('', this.bus)
          } else {
            this.$nextTick(() => {
              this.$refs.inputForm.resetFields()
            })
          }
        }
      }
    },
    methods: {
      getKeyWatch (keyWatch) {
        this.keyWatch = keyWatch
      },
      getUpload () {
      },
      init (method, id) {
        this.method = method
        this.inputForm = {
          userName: '',
          no: '',
          department: '',
          reimDate: '',
          remarks: '',
          detailInfos: [],
          detailInfoContracts: [],
          detailInfoReports: [],
          detailInfoOthers: [],
          detailInfoProcured: [],
          amountInfos: [],
          files: [], // 附件信息
          procInsId: '',
          sourceType: '',
          preList: [],
          purchaseNo: '',
          tradeTotalPrice: '',
          purchaseId: '',
          departmentName: ''
        }
        if (method === 'add') {
          this.title = `新建报销类型`
        } else if (method === 'edit') {
          this.title = '修改报销类型'
        }
        this.inputForm.id = id
        this.visible = true
        this.loading = false
        this.$nextTick(() => {
          this.loading = true
          this.$refs.inputForm.resetFields()
          this.$refs.uploadComponent.clearUpload()
          this.reimbursementService.findById(this.inputForm.id).then(({data}) => {
            if (this.status === 'audit' || this.status === 'taskFormDetail') {
              method = 'view'
            }
            this.inputForm = this.recover(this.inputForm, data)
            this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
            if (this.commonJS.isEmpty(this.inputForm.department)) {
              this.inputForm.department = JSON.parse(localStorage.getItem('user')).officeDTO.id
              this.inputForm.departmentName = JSON.parse(localStorage.getItem('user')).officeDTO.name
            }
            if (this.commonJS.isEmpty(this.inputForm.userId)) {
              this.inputForm.userId = JSON.parse(localStorage.getItem('user')).id
            }
            if (this.commonJS.isEmpty(this.inputForm.userName)) {
              this.inputForm.userName = JSON.parse(localStorage.getItem('user')).name
            }
            if (this.commonJS.isEmpty(this.inputForm.reimDate)) {
              this.inputForm.reimDate = new Date()
            }
            this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'reimbursement')
            if (this.commonJS.isNotEmpty(this.inputForm.purchaseId)) {
              this.startPur(this.inputForm.purchaseId)
            }
            this.loading = false
          })
          if (method !== 'edit' && method !== 'view') {
            this.$refs.uploadComponent.newUpload(method, [], 'reimbursement')
          }
        })
      },
      // 表单提交
      doSubmit () {
        this.$refs['inputForm'].validate((valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            this.inputForm.id = this.businessId
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.reimbursementService.save(this.inputForm).then(({data}) => {
              this.close()
              this.$message.success(data)
              this.$emit('refreshDataList')
              this.loading = false
            }).catch(() => {
              this.loading = false
            })
            // this.reimbursementService.save(this.inputForm).then(({data}) => {
            //   this.close()
            //   this.$message.success(data)
            //   this.$emit('refreshDataList')
            //   this.loading = false
            // }).catch(() => {
            //   this.loading = false
            // })
          }
        })
      },
      close () {
        this.inputForm.detailInfos = []
        this.inputForm.detailInfoContracts = []
        this.inputForm.detailInfoReports = []
        this.inputForm.detailInfoOthers = []
        this.inputForm.detailInfoProcured = []
        this.inputForm.purchaseNo = ''
        this.inputForm.preList = ''
        this.inputForm.purchaseId = ''
        this.$refs.inputForm.resetFields()
        this.inputForm.amountInfos = []
        this.$refs.uploadComponent.clearUpload()
        this.visible = false
      },
      // 删除
      removeEvent (row, rowIndex, type) {
        if (type === 'detail') {
          this.$refs.detailTable.remove(row)
          this.inputForm.detailInfos.splice(rowIndex, 1)
        }
        if (type === 'amount') {
          this.$refs.amountTable.remove(row)
          this.inputForm.amountInfos.splice(rowIndex, 1)
        }
        if (type === 'contract_detail') {
          this.$refs.detailTableContract.remove(row)
          this.inputForm.detailInfoContracts.splice(rowIndex, 1)
        }
        if (type === 'report_detail') {
          this.$refs.detailTableReport.remove(row)
          this.inputForm.detailInfoReports.splice(rowIndex, 1)
        }
        if (type === 'others') {
          this.$refs.detailTableOthers.remove(row)
          this.inputForm.detailInfoOthers.splice(rowIndex, 1)
        }
        if (type === 'procured') {
          this.$refs.detailTableProcured.remove(row)
          this.inputForm.detailInfoProcured.splice(rowIndex, 1)
        }
      },
      // 新增
      async insertEvent (type) {
        if (type === 'detail') {
          let d = {
            userName: JSON.parse(localStorage.getItem('user')).name,
            deptName: JSON.parse(localStorage.getItem('user')).officeDTO.name,
            userId: JSON.parse(localStorage.getItem('user')).id,
            deptId: JSON.parse(localStorage.getItem('user')).officeDTO.id
          }
          if (this.commonJS.isEmpty(this.inputForm.detailInfos)) {
            this.inputForm.detailInfos = []
          }
          this.$refs.detailTable.insertAt(d)
          this.inputForm.detailInfos.push(d)
          this.detailKey = Math.random()
        }
        if (type === 'amount') {
          let d = {}
          if (this.commonJS.isEmpty(this.inputForm.amountInfos)) {
            this.inputForm.amountInfos = []
          }
          this.$refs.amountTable.insertAt(d)
          this.inputForm.amountInfos.push(d)
          this.amountKey = Math.random()
        }
        if (type === 'contract_detail') {
          let d = {
            userName: JSON.parse(localStorage.getItem('user')).name,
            deptName: JSON.parse(localStorage.getItem('user')).officeDTO.name,
            userId: JSON.parse(localStorage.getItem('user')).id,
            deptId: JSON.parse(localStorage.getItem('user')).officeDTO.id
          }
          if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts)) {
            this.inputForm.detailInfoContracts = []
          }
          this.$refs.detailTableContract.insertAt(d)
          this.inputForm.detailInfoContracts.push(d)
          this.detailKeyContract = Math.random()
        }
        if (type === 'report_detail') {
          let d = {
            userName: JSON.parse(localStorage.getItem('user')).name,
            deptName: JSON.parse(localStorage.getItem('user')).officeDTO.name,
            userId: JSON.parse(localStorage.getItem('user')).id,
            deptId: JSON.parse(localStorage.getItem('user')).officeDTO.id
          }
          if (this.commonJS.isEmpty(this.inputForm.detailInfoReports)) {
            this.inputForm.detailInfoReports = []
          }
          this.$refs.detailTableReport.insertAt(d)
          this.inputForm.detailInfoReports.push(d)
          this.detailKeyReport = Math.random()
        }
        if (type === 'others') {
          let d = {
            userName: JSON.parse(localStorage.getItem('user')).name,
            deptName: JSON.parse(localStorage.getItem('user')).officeDTO.name,
            userId: JSON.parse(localStorage.getItem('user')).id,
            deptId: JSON.parse(localStorage.getItem('user')).officeDTO.id
          }
          if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers)) {
            this.inputForm.detailInfoOthers = []
          }
          this.$refs.detailTableOthers.insertAt(d)
          this.inputForm.detailInfoOthers.push(d)
          this.detailKeyOthers = Math.random()
        }
        if (type === 'procured') {
          let d = {
            userName: JSON.parse(localStorage.getItem('user')).name,
            deptName: JSON.parse(localStorage.getItem('user')).officeDTO.name,
            userId: JSON.parse(localStorage.getItem('user')).id,
            deptId: JSON.parse(localStorage.getItem('user')).officeDTO.id
          }
          if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured)) {
            this.inputForm.detailInfoProcured = []
          }
          this.$refs.detailTableProcured.insertAt(d)
          this.inputForm.detailInfoProcured.push(d)
          this.detailKeyProcured = Math.random()
        }
      },
      // 暂存
      async saveForm (callback) {
        this.loading = true
        if (this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          return
        }
        if (this.commonJS.isEmpty(this.inputForm.files)) {
          this.inputForm.files = []
        }
        this.inputForm.files = this.$refs.uploadComponent.getDataList()
        this.inputForm.type = '1'
        this.reimbursementService.save(this.inputForm).then(({data}) => {
          callback()
          this.$refs.inputForm.resetFields()
          this.loading = false
        }).catch(() => {
          this.$refs.inputForm.resetFields()
          this.loading = false
        })
        // this.reimbursementService.save(this.inputForm).then(({data}) => {
        //   callback()
        //   this.$refs.inputForm.resetFields()
        //   this.loading = false
        // }).catch(() => {
        //   this.$refs.inputForm.resetFields()
        //   this.loading = false
        // })
      },
      reapplyForm (callback) {
        this.startForm(callback)
      },
      // 送审
      async startForm (callback) {
        this.$refs['inputForm'].validate(async (valid) => {
          if (valid) {
            this.loading = true
            this.submitCheck()
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            // if (this.commonJS.isEmpty(this.inputForm.amountInfos)) {
            //   this.$message.error('至少填写一条专用发票信息')
            //   this.loading = false
            //   return
            // }
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.inputForm.type = '2'
            this.reimbursementService.save(this.inputForm).then(({data}) => {
              callback(data.businessTable, data.businessId, this.inputForm)
              this.$refs.inputForm.resetFields()
              this.loading = false
            }).catch(() => {
              this.$refs.inputForm.resetFields()
              this.loading = false
            })
            // this.reimbursementService.save(this.inputForm).then(({data}) => {
            //   callback(data.businessTable, data.businessId, this.inputForm)
            //   this.$refs.inputForm.resetFields()
            //   this.loading = false
            // }).catch(() => {
            //   this.$refs.inputForm.resetFields()
            //   this.loading = false
            // })
          }
        })
      },
      // 通过
      async agreeForm (callback) {
        this.$refs['inputForm'].validate(async (valid) => {
          if (valid) {
            this.loading = true
            this.submitCheck()
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then(({data}) => {
              if (this.commonJS.isNotEmpty(data)) {
                if (data === '所长审批') {
                  this.inputForm.type = '5'
                }
              }
              this.reimbursementService.save(this.inputForm).then(({data}) => {
                callback(data.businessTable, data.businessId, this.inputForm)
                this.loading = false
              }).catch(() => {
                this.loading = false
              })
            })
          }
        })
      },
      // 修改状态
      updateStatusById (type, callback) {
        if (type === 'reject') {
          this.inputForm.type = '4'
          this.reimbursementService.updateStatusById(this.inputForm).then(() => {
            callback()
          })
          // this.reimbursementService.updateStatusById(this.inputForm)
        } else if (type === 'hold') {
          this.inputForm.type = '1'
          this.reimbursementService.updateStatusById(this.inputForm).then(() => {
            callback()
          })
        }
      },
      footerMethod ({ columns, data }) {
        const footerData = [
          columns.map((column, columnIndex) => {
            if (columnIndex === 0) {
              return '总报销费用'
            }
            if (['number'].includes(column.property)) {
              // eslint-disable-next-line no-undef
              return XEUtils.sum(data, column.property)
            }
            return null
          })
        ]
        return footerData
      },
      twoDecimalPlaces (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`金额小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      isExict (row) {
        this.reimbursementService.checkNumber(row.number).then(({data}) => {
          if (data) {
            this.$message.error('该发票号已存在')
            row.number = ''
          }
        })
        // this.reimbursementService.checkNumber(row.number).then(({data}) => {
        //   if (data) {
        //     this.$message.error('该发票号已存在')
        //     row.number = ''
        //   }
        // })
      },
      countAmount (row) {
        let amount
        let taxAmount
        let count = 0
        if (!this.commonJS.isEmpty(row.amount)) {
          amount = parseFloat(row.amount)
          count = count + amount
        }
        if (!this.commonJS.isEmpty(row.taxAmount)) {
          taxAmount = parseFloat(row.taxAmount)
          count = count + taxAmount
        }
        row.count = parseFloat(count).toFixed(2)
      },
      // 选择报告号
      openReportNoPageForm (rowIndex, row) {
        if (this.commonJS.isEmpty(row.projectName)) {
          this.$message.error('请选择报销项目')
          return
        }
        this.indexRow = rowIndex
        // let i = this.inputForm.detailInfos.length
        this.$refs.reportNoChooseRadio.init(this.inputForm.detailInfoReports[rowIndex].projectId)
        // for (let j = this.indexRow; j < i; j++) {
        //   if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].projectName)) {
        //     console.log('this.inputForm.detailInfos[j].projectName', this.inputForm.detailInfos[j].projectName)
        //     this.$refs.reportNoChooseRadio.init(this.inputForm.detailInfos[j].projectName)
        //   }
        // }
      },
      openProgramPageForm (rowIndex, row) {
        if (this.commonJS.isEmpty(row.typeName)) {
          this.$message.error('请选择报销类型')
          return
        }
        this.indexRow = rowIndex
        this.reimbursementTypeService.findById(row.typeId).then(({data}) => {
          console.log('typeInfo', data.sort)
          console.log('data', data)
          let i = data.sort.toString()
          i = i.substring(0, 1)
          // 非业务报销
          console.log('i', i)
          if (i !== '1') {
            this.$refs.cwProgramPageForm.init('2', false)
          } else {
            // 打开单选组件
            this.$refs.cwProgramPageForm.init('1', false)
          }
        })
      },
      openProgramPageForm3 (rowIndex, row) {
        if (this.commonJS.isEmpty(row.typeName)) {
          this.$message.error('请选择报销类型')
          return
        }
        this.indexRow = rowIndex
        this.reimbursementTypeService.findById(row.typeId).then(({data}) => {
          let i = data.sort.toString()
          i = i.substring(0, 1)
          // 非业务报销
          if (i !== '1') {
            this.$refs.cwProgramPageForm3.init('2', false)
          } else {
            // 打开单选组件
            this.$refs.cwProgramPageForm3.init('1', false)
          }
        })
      },
      openProgramPageForm4 (rowIndex, row) {
        if (this.commonJS.isEmpty(row.typeName)) {
          this.$message.error('请选择报销类型')
          return
        }
        this.indexRow = rowIndex
        this.$refs.cwProgramPageForm4.init('2', false)
      },
      openProgramPageForm5 (rowIndex, row) {
        if (this.commonJS.isEmpty(row.typeName)) {
          this.$message.error('请选择报销类型')
          return
        }
        this.indexRow = rowIndex
        this.$refs.cwProgramPageForm5.init('2', false)
      },
      openContractForm (rowIndex, row) {
        this.$refs.workContractChooseCom.init(rowIndex)
      },
      getProgram (rows) {
        this.inputForm.detailInfos[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].projectName = rows[0].projectName
        this.inputForm.detailInfos[this.indexRow].reportNumber = rows[0].reportNumber
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgram3 (rows) {
        this.inputForm.detailInfoReports[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfoReports[this.indexRow].projectName = rows[0].projectName
        this.inputForm.detailInfoReports[this.indexRow].reportNumber = rows[0].reportNumber
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgram4 (rows) {
        this.inputForm.detailInfoOthers[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfoOthers[this.indexRow].projectName = rows[0].projectName
        this.inputForm.detailInfoOthers[this.indexRow].reportNumber = rows[0].reportNumber
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgram5 (rows) {
        this.inputForm.detailInfoProcured[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfoProcured[this.indexRow].projectName = rows[0].projectName
        this.inputForm.detailInfoProcured[this.indexRow].reportNumber = rows[0].reportNumber
        this.indexRow = ''
        this.$forceUpdate()
      },
      // 报销类型下拉弹窗
      typePullForm (rowIndex, deptName) {
        this.indexRow = rowIndex
        // this.$refs.reimbursementTypePullForm.init()
        this.$refs.cwReimbursementTypePullForm.init('1', deptName)
      },
      typePullForm2 (rowIndex, deptName) {
        this.indexRow = rowIndex
        // this.$refs.reimbursementTypePullForm.init()
        this.$refs.cwReimbursementTypePullForm2.init('2', deptName)
      },
      typePullForm3 (rowIndex, deptName) {
        this.indexRow = rowIndex
        // this.$refs.reimbursementTypePullForm.init()
        this.$refs.cwReimbursementTypePullForm3.init('1', deptName)
      },
      typePullForm4 (rowIndex, deptName) {
        this.indexRow = rowIndex
        // this.$refs.reimbursementTypePullForm.init()
        this.$refs.cwReimbursementTypePullForm4.init('2', deptName)
      },
      typePullForm5 (rowIndex, deptName) {
        this.indexRow = rowIndex
        // this.$refs.reimbursementTypePullForm.init()
        this.$refs.cwReimbursementTypePullForm5.init('2', deptName)
      },
      // 报销内容详情
      getProgramForType (rows) {
        this.inputForm.detailInfos[this.indexRow].typeId = rows.id
        this.inputForm.detailInfos[this.indexRow].typeName = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType2 (rows) {
        this.inputForm.detailInfoContracts[this.indexRow].typeId = rows.id
        this.inputForm.detailInfoContracts[this.indexRow].typeName = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType3 (rows) {
        this.inputForm.detailInfoReports[this.indexRow].typeId = rows.id
        this.inputForm.detailInfoReports[this.indexRow].typeName = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType4 (rows) {
        this.inputForm.detailInfoOthers[this.indexRow].typeId = rows.id
        this.inputForm.detailInfoOthers[this.indexRow].typeName = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType5 (rows) {
        this.inputForm.detailInfoProcured[this.indexRow].typeId = rows.id
        this.inputForm.detailInfoProcured[this.indexRow].typeName = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      // 报销人下拉弹窗
      userPullListForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm.init()
      },
      userPullListForm2 (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm2.init()
      },
      userPullListForm3 (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm3.init()
      },
      userPullListForm4 (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm4.init()
      },
      userPullListForm5 (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm5.init()
      },
      getProgramForUser (rows) {
        this.inputForm.detailInfos[this.indexRow].userId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].userName = rows[0].name
        this.inputForm.detailInfos[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfos[this.indexRow].deptName = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForUser2 (rows) {
        this.inputForm.detailInfoContracts[this.indexRow].userId = rows[0].id
        this.inputForm.detailInfoContracts[this.indexRow].userName = rows[0].name
        this.inputForm.detailInfoContracts[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfoContracts[this.indexRow].deptName = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForUser3 (rows) {
        this.inputForm.detailInfoReports[this.indexRow].userId = rows[0].id
        this.inputForm.detailInfoReports[this.indexRow].userName = rows[0].name
        this.inputForm.detailInfoReports[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfoReports[this.indexRow].deptName = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForUser4 (rows) {
        this.inputForm.detailInfoOthers[this.indexRow].userId = rows[0].id
        this.inputForm.detailInfoOthers[this.indexRow].userName = rows[0].name
        this.inputForm.detailInfoOthers[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfoOthers[this.indexRow].deptName = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForUser5 (rows) {
        this.inputForm.detailInfoProcured[this.indexRow].userId = rows[0].id
        this.inputForm.detailInfoProcured[this.indexRow].userName = rows[0].name
        this.inputForm.detailInfoProcured[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfoProcured[this.indexRow].deptName = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getWorkClientChoose2 (list) {
        this.inputForm.detailInfoReports[this.indexRow].reportNumber = list.reportNo
        this.indexRow = ''
        this.$forceUpdate()
      },
      getContract (row, rowIndex) {
        this.inputForm.detailInfoContracts[rowIndex].contractId = row.id
        this.inputForm.detailInfoContracts[rowIndex].contractName = row.contractName
        this.$forceUpdate()
      },
      changeSourceType () {
        this.inputForm.detailInfos = []
        this.inputForm.detailInfoContracts = []
        this.inputForm.detailInfoReports = []
        this.inputForm.detailInfoOthers = []
        this.inputForm.detailInfoProcured = []
        this.inputForm.purchaseNo = ''
        this.inputForm.preList = ''
        this.inputForm.purchaseId = ''
        this.detailKey = Math.random()
        this.detailKeyContract = Math.random()
        this.detailKeyReport = Math.random()
        this.detailKeyOthers = Math.random()
        this.detailKeyProcured = Math.random()
      },
      submitCheck () {
        if (this.commonJS.isEmpty(this.inputForm.sourceType)) {
          this.$message.error('请填写报销类型')
          this.loading = false
          throw new Error('请填写报销类型')
        } else {
          if (this.inputForm.sourceType === '1') {
            if (this.commonJS.isEmpty(this.inputForm.detailInfos)) {
              this.$message.error('至少填写一条报销详情信息')
              this.loading = false
              throw new Error('至少填写一条报销详情信息')
            } else {
              let i = this.inputForm.detailInfos.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].userName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销人')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销人')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].typeName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销类型')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销类型')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].projectName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销项目')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销项目')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].number)) {
                  this.$message.error('报销详情第' + k + '行请输入费用')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请输入费用')
                }
              }
            }
          } else if (this.inputForm.sourceType === '2') {
            if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts)) {
              this.$message.error('至少填写一条报销详情信息')
              this.loading = false
              throw new Error('至少填写一条报销详情信息')
            } else {
              let i = this.inputForm.detailInfoContracts.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts[j].userName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销人')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销人')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts[j].typeName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销类型')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销类型')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts[j].contractName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销合同')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销合同')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoContracts[j].number)) {
                  this.$message.error('报销详情第' + k + '行请输入费用')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请输入费用')
                }
              }
            }
          } else if (this.inputForm.sourceType === '3') {
            if (this.commonJS.isEmpty(this.inputForm.detailInfoReports)) {
              this.$message.error('至少填写一条报销详情信息')
              this.loading = false
              throw new Error('至少填写一条报销详情信息')
            } else {
              let i = this.inputForm.detailInfoReports.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfoReports[j].userName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销人')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销人')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoReports[j].typeName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销类型')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销类型')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoReports[j].projectName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销项目')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销项目')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoReports[j].reportNumber)) {
                  this.$message.error('报销详情第' + k + '行请选择报告号')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报告号')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoReports[j].number)) {
                  this.$message.error('报销详情第' + k + '行请输入费用')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请输入费用')
                }
              }
            }
          } else if (this.inputForm.sourceType === '4') {
            if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers)) {
              this.$message.error('至少填写一条报销详情信息')
              this.loading = false
              throw new Error('至少填写一条报销详情信息')
            } else {
              let i = this.inputForm.detailInfoOthers.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers[j].userName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销人')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销人')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers[j].typeName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销类型')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销类型')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers[j].projectName)) {
                  this.$message.error('报销详情第' + k + '行请填写报销详情')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请填写报销详情')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoOthers[j].number)) {
                  this.$message.error('报销详情第' + k + '行请输入费用')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请输入费用')
                }
              }
            }
          } else if (this.inputForm.sourceType === '5') {
            if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured)) {
              this.$message.error('至少填写一条报销详情信息')
              this.loading = false
              throw new Error('至少填写一条报销详情信息')
            } else {
              let i = this.inputForm.detailInfoProcured.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured[j].userName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销人')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销人')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured[j].typeName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销类型')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销类型')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured[j].projectName)) {
                  this.$message.error('报销详情第' + k + '行请选择报销项目')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请选择报销项目')
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfoProcured[j].number)) {
                  this.$message.error('报销详情第' + k + '行请输入费用')
                  this.loading = false
                  throw new Error('报销详情第' + k + '行请输入费用')
                }
              }
            }
          }
        }
      },
      openPurForm () {
        this.$refs.purchaseChooseForm.init()
      },
      startPur (id) {
        this.materialManagementService.findById(id).then(({data}) => {
          this.inputForm.preList = data.detailInfos
          this.inputForm.purchaseNo = data.purchaseNo
          let i = this.inputForm.preList.length
          for (let j = 0; j < i; j++) {
            if (this.commonJS.isNotEmpty(this.inputForm.preList[j].tradePrice)) {
              if (this.commonJS.isNotEmpty(this.inputForm.preList[j].tradeNumber)) {
                this.inputForm.preList[j].priceSum = this.inputForm.preList[j].tradePrice * this.inputForm.preList[j].tradeNumber
              }
            }
          }
        })
        this.$forceUpdate()
      },
      getPurChoose (row) {
        this.inputForm.purchaseId = row.id
        this.startPur(row.id)
      },
      footerMethod555 ({ columns, data }) {
        const footerData = [
          columns.map((column, columnIndex) => {
            if (columnIndex === 0) {
              return '商品总价'
            }
            if (['priceSum'].includes(column.property)) {
              // eslint-disable-next-line no-undef
              this.inputForm.tradeTotalPrice = XEUtils.sum(data, column.property)
              return XEUtils.sum(data, column.property)
            }
            return null
          })
        ]
        return footerData
      },
      seeFileInfo (index) {
        if (this.commonJS.isEmpty(this.inputForm.preList[index].fileInfoLost)) {
          this.inputForm.preList[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload('view', this.inputForm.preList[index].fileInfoLost, null, null, null, null, null, false, index)
      }
    }
  }
</script>
